#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

typedef struct prijava {
	char brIndeksa[10];
	char predmet[30];
	int ocena;
}PRIJAVA;
typedef struct cvor *PCVOR;
typedef struct cvor {
	PRIJAVA prijava;
	PCVOR sledeci;
}CVOR;
typedef struct izvestaj {
	char brIndeksa[10];
	int brojPolozenih;
	int sumaOcena;
}IZVESTAJ;
typedef struct cvorIzv *PCVORIZV;
typedef struct cvorIzv {
	IZVESTAJ podatak;
	PCVORIZV sledeci;
}CVORIZV;


void izNizaUDat(PRIJAVA XP[], int n, char naziv[]);
void izDatUListu(char naziv[], PCVOR *glava);
void prikaziListu(PCVOR glava);
void formirajIzvestaj(PCVOR glava, char naziv[]);
PCVORIZV postoji(PCVORIZV glavaIzv, char brIndeksa[]);


int main() {
	PCVOR glava = NULL;
	PRIJAVA XP[] = {
		{"2018/1","p1",5},
		{"2018/2","p1",10},
		{"2018/2","p2",8}
	};
	int n = 3;
	izNizaUDat(XP, n, "podaci.dat");
	izDatUListu("podaci.dat", &glava);
	prikaziListu(glava);
	formirajIzvestaj(glava, "izvestaj.txt");

	system("pause");
	return 0;
}

void izNizaUDat(PRIJAVA XP[], int n, char naziv[]) {
	FILE *datoteka = fopen(naziv, "wb");
	if (datoteka == NULL) {
		printf("Greska!\n");
		return;
	}
	fwrite(XP, sizeof(PRIJAVA), n, datoteka);

	fclose(datoteka);
}

void izDatUListu(char naziv[], PCVOR *glava) {
	FILE *datoteka = fopen(naziv, "rb");
	if (datoteka == NULL) {
		printf("Greska!\n");
		return;
	}
	PRIJAVA p;
	while (fread(&p, sizeof(PRIJAVA), 1, datoteka) > 0) {
		PCVOR novi;
		novi = malloc(sizeof(CVOR));
		novi->prijava = p;
		novi->sledeci = *glava;
		*glava = novi;
	}
	fclose(datoteka);
}

void prikaziListu(PCVOR glava) {
	printf("%15s%30s%10s\n", "Br.Indeksa", "Predmet", "Ocena");
	while (glava != NULL) {
		printf("%15s%30s%10d\n", glava->prijava.brIndeksa, glava->prijava.predmet, glava->prijava.ocena);
		glava = glava->sledeci;
	}
	printf("\n");
}

void formirajIzvestaj(PCVOR glava, char naziv[]) {
	//formiraj listu izvestaj
	PCVORIZV glavaIzv = NULL;
	while (glava != NULL) {
		PCVORIZV signal = postoji(glavaIzv, glava->prijava.brIndeksa);
		if (signal == NULL) {
			PCVORIZV novi;
			novi = malloc(sizeof(CVORIZV));
			strcpy(novi->podatak.brIndeksa, glava->prijava.brIndeksa);
			novi->podatak.brojPolozenih = 1;
			novi->podatak.sumaOcena = glava->prijava.ocena;
			novi->sledeci = glavaIzv;
			glavaIzv = novi;
		}
		else {
			signal->podatak.brojPolozenih += 1;
			signal->podatak.sumaOcena += glava->prijava.ocena;
		}

		glava = glava->sledeci;
	}

	//formiraj izvestaj u tekstualnoj datoteci
	FILE *datoteka = fopen(naziv, "w");
	if (datoteka == NULL) {
		printf("Greska!\n");
		return;
	}
	fprintf(datoteka, "%5s%15s%10s%10s\n", "RB.", "Student", "Br.Pol.", "Prosek");
	fprintf(datoteka, "----------------------------------------\n");
	PCVORIZV tek = glavaIzv;
	int brojac = 0;
	while (tek != NULL) {
		brojac++;
		fprintf(datoteka, "%5d.%15s%10d%10.2lf\n", brojac, tek->podatak.brIndeksa, tek->podatak.brojPolozenih,((double)tek->podatak.sumaOcena / tek->podatak.brojPolozenih));
		tek = tek->sledeci;
	}

	fclose(datoteka);
}

PCVORIZV postoji(PCVORIZV glavaIzv, char brIndeksa[]) {
	while (glavaIzv != NULL) {
		if (strcmp(glavaIzv->podatak.brIndeksa, brIndeksa) == 0) return glavaIzv;
		glavaIzv = glavaIzv->sledeci;
	}
	return NULL;
}